#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMessageBox>
#include <QInputDialog>
#include <iostream>
#include <QDebug>
#include <QTableWidget>

#include <qsmatrix.h>
#include <program.h>


#define NODEP "0"
#define IDENTITY "L"
#define ADDED   "A"
#define MULT "M"



namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();


protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    int sizeMatrix;

    QSMatrix *firstMatrix;
    QSMatrix *secondMatrix;
    QSMatrix *thirdMatrix;

    void resizeColumnsRows();
    void copyToTableWidget(QSMatrix *matrixQS, QTableWidget *tableWidget);
    void copyToLocalMatrix(QTableWidget *tableWidget, QSMatrix *matrixQS);

    void saveAllMatrixes();
    void restoreAllMatrixes();

    QString addElement(QString a, QString b);
    QString multElement(QString a, QString b);
    QString unionElement(QString a, QString b);
    void standardizeMatrixes();
    bool areEqual(QTableWidget* a, QTableWidget* b);

    //copies
    void copyMatrixes(QSMatrix *a, QSMatrix *b);
    void resetMatrix(QSMatrix *a);

private slots:
    void on_actionCrete_Matrix_triggered();
    void on_actionUnion_Closure_triggered();
    void on_actionMultiplication_Closure_triggered();

    //operations
    void addMatrix();
    void multMatrix();
    void unionMatrix();

    //copies matrixes
    void firstToSecond();
    void secondToFirst();
    void thirdToFirst();
    void thirdToSecond();
    void resetOne();
    void resetTwo();
    void resetThree();

    //parse the program written in the textbox
    void parseAndTypeProgram();

};

#endif // MAINWINDOW_H
