#include "program.h"

namespace client
{
    namespace qi = boost::spirit::qi;
    namespace ascii = boost::spirit::ascii;

    ///////////////////////////////////////////////////////////////////////////
    //  Our number list parser
    ///////////////////////////////////////////////////////////////////////////
    //[tutorial_numlist1
    template <typename Iterator>
    bool parse_numbers(Iterator first, Iterator last)
    {
        using qi::double_;
        using qi::phrase_parse;
        using ascii::space;

        bool r = phrase_parse(
            first,                          /*< start iterator >*/
            last,                           /*< end iterator >*/
            double_ >> *(',' >> double_),   /*< the parser >*/
            space                           /*< the skip-parser >*/
        );
        if (first != last) // fail if we did not get a full match
             return false;
         return r;
    }
}



Program::Program(string programToParser)
{
    if( !( client::parse_numbers(programToParser.begin(), programToParser.end()) ) )
    {
        cout << "non è corretta la stringa" <<endl;
    }
    else
        cout << "LA stringa è corretta " <<endl;
}
