#ifndef QSMATRIX_H
#define QSMATRIX_H

#define E_NODEP    0
#define E_IDENTITY 1
#define E_ADDED    2
#define E_MULT     3

#include <QVector>
#include <vector>
#include <algorithm>
#include <math.h>
#include <string>
#include <sstream>
#include <iostream>

using namespace std;

class QSMatrix
{
private:
    int sizeMatrix;
    QVector<int> *internalMatrix;

public:
    QSMatrix(int size);
    ~QSMatrix();

    int  getElementAt(int row, int column);
    void setElementAt(int row, int column, int element);
    int getSize();
    void reset();

    //static methods
    //operations with matrixes
    static void multiplication(QSMatrix *a, QSMatrix *b, QSMatrix *result);
    static void addition(QSMatrix *a, QSMatrix *b, QSMatrix *result);
    static void unions(QSMatrix *a, QSMatrix *b, QSMatrix *result);


    static bool areEqual(QSMatrix *a, QSMatrix *b);



    //operation with elements
    static int multElement (int a, int b);
    static int addElement  (int a, int b);
    static int unionElement(int a, int b);

    //gives an order
    static void getSuccessor(QSMatrix *a);
    static void getSuccessorWIndex(QSMatrix *a, int row, int column);

    string toString();
};

#endif // QSMATRIX_H
